/*******************************************************************************
 * Copyright (c) 2007 University of Illinois at Urbana-Champaign and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *     UIUC - Initial API and implementation
 *******************************************************************************/
package org.eclipse.photran.internal.core.parser;

import java.io.PrintStream;
import java.util.Iterator;

import java.util.List;

import org.eclipse.photran.internal.core.parser.Parser.ASTNode;
import org.eclipse.photran.internal.core.parser.Parser.ASTNodeWithErrorRecoverySymbols;
import org.eclipse.photran.internal.core.parser.Parser.IASTListNode;
import org.eclipse.photran.internal.core.parser.Parser.IASTNode;
import org.eclipse.photran.internal.core.parser.Parser.IASTVisitor;
import org.eclipse.photran.internal.core.lexer.Token;

import org.eclipse.photran.internal.core.lexer.*;                   import org.eclipse.photran.internal.core.analysis.binding.ScopingNode;

public class ASTEndSelectTypeStmtNode extends ASTNode
{
    org.eclipse.photran.internal.core.lexer.Token hiddenTEndbeforeselect; // in ASTEndSelectTypeStmtNode
    org.eclipse.photran.internal.core.lexer.Token hiddenTEndselect; // in ASTEndSelectTypeStmtNode
    org.eclipse.photran.internal.core.lexer.Token hiddenTSelect; // in ASTEndSelectTypeStmtNode
    org.eclipse.photran.internal.core.lexer.Token selectConstructName; // in ASTEndSelectTypeStmtNode
    org.eclipse.photran.internal.core.lexer.Token hiddenTEos; // in ASTEndSelectTypeStmtNode

    public org.eclipse.photran.internal.core.lexer.Token getSelectConstructName()
    {
        return this.selectConstructName;
    }

    public void setSelectConstructName(org.eclipse.photran.internal.core.lexer.Token newValue)
    {
        this.selectConstructName = newValue;
    }


    public void accept(IASTVisitor visitor)
    {
        visitor.visitASTEndSelectTypeStmtNode(this);
        visitor.visitASTNode(this);
    }

    @Override protected int getNumASTFields()
    {
        return 5;
    }

    @Override protected IASTNode getASTField(int index)
    {
        switch (index)
        {
        case 0:  return this.hiddenTEndbeforeselect;
        case 1:  return this.hiddenTEndselect;
        case 2:  return this.hiddenTSelect;
        case 3:  return this.selectConstructName;
        case 4:  return this.hiddenTEos;
        default: return null;
        }
    }

    @Override protected void setASTField(int index, IASTNode value)
    {
        switch (index)
        {
        case 0:  this.hiddenTEndbeforeselect = (org.eclipse.photran.internal.core.lexer.Token)value; return;
        case 1:  this.hiddenTEndselect = (org.eclipse.photran.internal.core.lexer.Token)value; return;
        case 2:  this.hiddenTSelect = (org.eclipse.photran.internal.core.lexer.Token)value; return;
        case 3:  this.selectConstructName = (org.eclipse.photran.internal.core.lexer.Token)value; return;
        case 4:  this.hiddenTEos = (org.eclipse.photran.internal.core.lexer.Token)value; return;
        default: throw new IllegalArgumentException("Invalid index");
        }
    }
}

